%==========================================================================
%  Function: animation()
%       Plot an animation of a tractor with trailer.
%
%  Synopsis:
%      animation(x,u,dT)
%
%  Input Parameter:
%      -x: Statevector 4xN ist der State mit x=[x_T, y_T, beta, gamma]^T
%      -u: Eingang 1xN mit u = alpha
%      -dT: 1x1 Steptime in seconds
%       
%  Author: Peter Hofmeier
%  Systems control and optimization laboratory, 
%  Department of Microsystems Engineering (IMTEK),
%  University of Freiburg
% 
%  File Created: 07.06.2017
%==========================================================================
function animation(x,u,dT)
L1  = 6;    % Lnge der Traktors
L2 = 4;

% Plotten
figure;
% calculate Min and max value for the axis
minA = min(min(x(1:2,:)))-10; 
maxA = max(max(x(1:2,:)))+10;
axis equal;
axis([minA maxA minA maxA]);
title('Traktor mit Anhnger Simulation')
xlabel('X - [m]')
ylabel('Y - [m]')
for i = 2:length(x)
    cla % clear plot
    draw_tractor(x(:,i),u(i-1),L1,L2) 
    pause(dT) % wait for steptime   
end
end


