% =========================================================================
% Solution to the MatLab excercise on 19.06.2017
% Task 1
%
% AUTHOR: Peter Hofmeier, Fabien Jenne
% Systems control and optimization laboratory, 
% Department of Microsystems Engineering (IMTEK),
% University of Freiburg
% 
% File Created: 13.06.2017
% =========================================================================
%
% For more information see the corresponding pdf
% 

close all;

%% task (a) simulation
% lenght of a single integration step in seconds
stepTime = 0.01;
% number of time steps performed in simulation
numSteps = 1000;
% --> total simulated time is stepTime * numSteps = 10s

x_0 = [0; 0; 0; 0]; % initial State

U = 0.1*ones(1,numSteps); % Input

% Simulate System
[X, Y, T] = nlsim(@tractor_trailer_ode_v_pos, x_0, U, stepTime, @tractor_trailer_out);


%% task (b) plotting
% Plotting output
figure;
plot(T, Y)

title('Ausgangssignal des gesteuerten Traktors Vorwrtsrichtung');
legend('X_T', 'Y_T', 'X_A', 'Y_A', 'Location', 'SOUTHWEST');
xlabel('Zeit in s');
ylabel('Ort in m');


% Plotting States
figure;
plot(T, X)

title('Zustnde des gesteuerten Traktors Vorwrtsrichtung');
legend('X_T','Y_T','\beta','\gamma', 'Location', 'SOUTHWEST');
xlabel('Zeit in s');
hold on;


% plotting in X-Y Plane directions

figure()
plot(Y(1,:),Y(2,:))
hold on
plot(Y(3,:),Y(4,:));
title('Weg des gesteuerten Traktors Vorwrtsrichtung');
legend('Tractor','Trailer', 'Location', 'NORTHWEST');
xlabel('Ort in m');
ylabel('Ort in m');
hold on;
axis equal;

%% task (c) animation

% Animation
animation(X,U,stepTime);

%% task (d) negative velocity

[X, Y, T] = nlsim(@tractor_trailer_ode_v_neg, x_0, U, stepTime, @tractor_trailer_out);

% Plot Output
figure;
plot(T, Y)

title('Ausgangssignal des gesteuerten Traktors Rckwrtsrichtung');
legend('X_T', 'Y_T', 'X_A', 'Y_A', 'Location', 'SOUTHWEST');
xlabel('Zeit in s');
ylabel('Ort in m');

% Plot States
figure;
plot(T, X)

title('Zustnde des gesteuerten Traktors Rckwrtsrichtung');
legend('X_T','Y_T','\beta','\gamma', 'Location', 'SOUTHWEST');
xlabel('Zeit in s');
hold on;
 
% Plot X-Y Plane
figure()
plot(Y(1,:),Y(2,:))
hold on
plot(Y(3,:),Y(4,:));
title('Weg des gesteuerten Traktors Rckwrtsrichtung');
legend('Tractor','Trailer', 'Location', 'NORTHWEST');
xlabel('Ort in m');
ylabel('Ort in m');
hold on;
axis equal;

% Animation
animation(X,U,stepTime);

